require "test/camera"
require "test/object_manager"

love.filesystem.load("tiledmap.lua")()

function love.load()

	object_manager.init()
	TiledMap_Load("maps/level1.tmx")
	local obl = TiledMap_GetObjects()
	
	for i,obj in ipairs(obl) do
			object_manager:create_object(obj.name,obj.type,obj.x,obj.y,obj.w,obj.h,obj.args)
	end
	
	local f = love.graphics.newFont(12)
	
	
	
	camera:setPosition(464,364)
	love.graphics.setFont(f)
   

	love.graphics.setBackgroundColor(63,204,255)
end

function love.draw()

	love.graphics.reset()
	local x,y = camera:getPosition()
	TiledMap_DrawNearCam(x,y)
	
	camera:set()
	
	for i,v in pairs(object_manager:get_objects()) do
		if(v.g ~= false) then
			v:draw()
		--love.graphics.draw(v.g, v.x, v.y, v.r)
		--
			if(v.body ~= nil) then
				love.graphics.polygon("fill",v.body:getWorldPoints(v.shape:getPoints()))
			end
			
		elseif(v.body ~= nil) then 
			--love.graphics.polygon("fill",v.body:getWorldPoints(v.shape:getPoints()))
		end
	end
		--love.graphics.polygon("fill",object_manager.collision_list[1].body:getWorldPoints(object_manager.collision_list[1].shape:getPoints()))
	
	camera:unset()
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	 love.graphics.print(text, 10, 10)
	--love.graphics.print("Todos pueden volaaaaaar", 400, 300)
end

function love.quit()

end

function love.update(dt)
	
	local x,y = object_manager:get_tofollow()
	camera:setPosition(x,y)   
	msg_manager:update()
	object_manager:Update(dt)
	

   
end

function love.keypressed(key, unicode)
	if(key == "w") then
		msg_manager:send_message("Human","player1",{reason="up"})
	elseif(key == "a") then
		msg_manager:send_message("Human","player1",{reason="left"})
	elseif(key == "s") then
		
	elseif(key == "d") then
		msg_manager:send_message("Human","player1",{reason="right"})
	end
	
end

function love.keyreleased(key, unicode)
	if(key == "a") then
	msg_manager:send_message("Human","player1",{reason="stop"})
	elseif(key == "s") then
		
	elseif(key == "d") then
	msg_manager:send_message("Human","player1",{reason="stop"})
	end
	
end

function love.mousepressed(x, y, button)
   if button == 'l' then
		local x,y = camera:mousePosition()
		object_manager:create_object(nil,"prop",x,y,0,0,{gfx="gfx/box.png"})
   end
      if button == 'r' then
		local x,y = camera:mousePosition()
		object_manager:create_object(nil,"prop",x,y,0,0,{gfx="gfx/box2.png"})
   end
end
