player = {}
player.type = "player"
player.g = "gfx/cube.png"
player.update = true
player.alive = true
player.bullet_t = 0
player.w = 0
player.h = 0
player.r = 0
player.wdir = 0
player.c_inf = true
player.c_list = {}
player.c_persist = true
player.inAir = false
player.body_parts = {}

function player:new(x,y)
	local object = { x = x, y = y }
	setmetatable(object, { __index = player } )
	object.g = love.graphics.newImage(object.g)
	object.w = object.g:getWidth()
	object.h = object.g:getHeight()
	object.origin_x = object.w / 2
	object.origin_y = object.h / 2
	object.name = "player1"
	object.body = love.physics.newBody(object_manager.world,object.x,object.y,"dynamic")
	object.shape = love.physics.newRectangleShape(object.origin_x,object.origin_y,object.w,object.h-20)

	object.foot = love.physics.newRectangleShape(object.origin_x,object.origin_y+40,20,10)
	
	object.body_parts["body"] = love.physics.newFixture(object.body,object.shape,2)
	object.body_parts["body"]:setUserData({name=object.name,part="body"})

	object.body_parts["feet"] = love.physics.newFixture(object.body,object.foot,2)
	object.body_parts["feet"]:setSensor(true)
	object.body_parts["feet"]:setUserData({name=object.name,part="feet"})

	object.body:setFixedRotation(true)
	--object.body:setLinearDamping(5)
	object.wdir = 0
	return object
end

function player:Update(dt)
	
	self.x = self.body:getX()
	self.y = self.body:getY()
	self.r = self.body:getAngle()	
	if(self.wdir ~= 0) then
		self.body:applyForce(self.wdir,0)
	end
end

function player:collide(a,b,c)
	if(a:getUserData().part == "feet") then
			self.inAir = false
			print("Estoy a salvo en tierra")
	end
	
end

function player:read_msg(msg)


	if(msg.args.reason == "c_start") then
		print("-------------------------")
		--print(msg.to .. ":" .. msg.from .. " colisiono con mi " .. msg.args.part)
		--print(msg.to .. ":" .. msg.from .. " colisiono con mi " .. msg.args.part)
		if(msg.args.part == "feet") then
			self.inAir = false
			print("Estoy a salvo en tierra")
		end
	end
	
	if(msg.args.reason == "up") then
		if(self.inAir == false) then
			self.inAir = true
			self.body:applyLinearImpulse( 0 , -500 )
		end
	elseif(msg.args.reason == "left") then
		if(self.inAir==false) then
			self.wdir = -1000
		else
			self.wdir = -500
		end
	elseif(msg.args.reason == "down") then
	elseif(msg.args.reason == "right") then
		if(self.inAir==false) then
			self.wdir = 1000
		else
			self.wdir = 500
		end
	elseif(msg.args.reason == "stop") then
		self.wdir = 0
	end
	
	
end

function player:draw()
	love.graphics.draw(self.g,self.x,self.y,self.r)
	love.graphics.polygon("fill",self.body:getWorldPoints(self.shape:getPoints()))
	 love.graphics.setColor(193, 47, 14)
	love.graphics.polygon("fill",self.body:getWorldPoints(self.foot:getPoints()))
	 love.graphics.setColor(255, 255, 255)
end

function player:destroy()
	object.body_parts["body"]:setUserData(nil)
	object.body_parts["feet"]:setUserData(nil)
	self.body:destroy()
end

