prop = {}
prop.type = "prop"
prop.g = "gfx/cube2.png"
prop.update = true
prop.alive = true
prop.w = 0
prop.h = 0
prop.r = 0
prop.count = 0
prop.c_inf = false

function prop:new(name,x,y,args)
	local object = {name = name, x = x, y = y , alive = true}
	setmetatable(object, { __index = prop } )
	prop.count = prop.count + 1

	if(object.name == nil) then
	object.name = "prop" .. prop.count
	end
	
	--print(object.name)
	--print(object.name)
	object.g = args["gfx"]
	object.g = love.graphics.newImage(object.g)
	object.w = object.g:getWidth()
	object.h = object.g:getHeight()
	object.origin_x = object.w / 2
	object.origin_y = object.h / 2
	object.body = love.physics.newBody(object_manager.world,object.x ,object.y ,"dynamic")
	object.shape = love.physics.newRectangleShape(object.origin_x,object.origin_y,object.w,object.h)
	object.fixture = love.physics.newFixture(object.body,object.shape,2)
	object.fixture:setUserData({name=object.name})

	return object
end

function prop:Update(dt)
	self.x = self.body:getX()
	self.y = self.body:getY()
	self.r = self.body:getAngle()
end

function prop:read_msg(msg)
	if(msg.args.reason == "kill") then
		self.alive = false
	end
end

function prop:draw()
	love.graphics.draw(self.g, self.x, self.y, self.r)
end

function prop:destroy()
	self.fixture:setUserData(nil)
	self.body:destroy()
end

