trigger = {}
trigger.type = "trigger"
trigger.g = false
trigger.update = false
trigger.alive = true
trigger.count = 0
trigger.c_inf = true



function trigger:new(name,x,y,w,h,args)
	local object = {x = x, y = y ,w = w, h = h, args = args}
	setmetatable(object, { __index = trigger } )
	
	trigger.count = trigger.count + 1
	
	object.type = "trigger_" .. args.type
	object.name = "trigger".. trigger.count ..  "_" .. args.type
	object.c_inf = true
	
	object.body = love.physics.newBody( object_manager.world,x+w/2,y+h/2,"static" )
	object.shape = love.physics.newRectangleShape( w, h )
	
	object.fixture = love.physics.newFixture(object.body,object.shape)
	object.fixture:setUserData({name=object.name})
	object.fixture:setSensor(true)

	return object
end

function trigger:read_msg(msg)
	if(msg.args.reason == "c_start") then
		msg_manager:send_message(self.name,self.args.action,{reason=1})
	end
end

function trigger:collide(a,b,c)
	--print(object_manager.object_list[object_manager:getObjectByName(self.args.action)].name)
	if(object_manager.object_list[object_manager:getObjectByName(self.args.action)] ~= nil) then
		object_manager.object_list[object_manager:getObjectByName(self.args.action)]:activate()
	end
end